export default interface AuthenticateOptions {
  /**
   * Authentication challenge GET request URL
   *
   * This URL should respond to a GET request with a cryptographic nonce.
   * The request will be made by the browser extension. The extension will
   * use this nonce to generate an authentication token.
   *
   * @example
   *   // Example response from the server
   *   {"nonce": "<nonce>"}
   */
  getAuthChallengeUrl: string;

  /**
   * Authentication token POST request URL
   *
   * This URL should accept a JSON payload via a POST request which contains
   * the authentication token generated by the browser extension.
   *
   * After the server validates the token,the server should respond
   * with a 2xx status code and an optional JSON payload.
   *
   * If the provided token was invalid or the user should be forbidden access
   * for a different reason, the server should respond with an appropriate
   * HTTP error status code and an optional JSON payload.
   *
   * The authenticate method will resolve or reject with
   * the optional JSON payload if the server chooses to provide it.
   *
   * @example
   *   // Example request payload
   *   {"token": "<base64 openid-x509 token JWT>"}
   */
  postAuthTokenUrl: string;

  /**
   * Headers to append to the requests.
   */
  headers?: {
    [key: string]: string;
  };

  /**
   * Time in milliseconds before a user interaction, for example PIN entry, times out.
   *
   * When not specified, defaults to 2 minutes.
   */
  userInteractionTimeout?: number;

  /**
   * Time in milliseconds before a server request, for example auth challenge request, times out.
   *
   * When not specified, defaults to 20 seconds.
   */
  serverRequestTimeout?: number;
}
